#pragma once
#include "BaseDlgStyleOne.h"

const UINT WM_HTTPDOWNLOAD_THREAD_FINISHED = WM_APP + 1;

#define FRAME_WIDTH				4
#define PROFILE_DLG_WIDTH		480
#define PROFILE_DLG_HEIGHT		455

#define COLOR_NORMAL_TEXT		(RGB(34, 34, 34))		// #222222
#define COLOR_NORMAL_BK			(RGB(255, 255, 255))
#define COLOR_STATIC_TEXT		(RGB(78, 157, 199))		// #4e9dc7
#define COLOR_LIST_BORDER		(RGB(220,220,220))		// #dcdcdc
#define COLOR_IMAGE_BORDER		(RGB(198, 198, 198))	// #c6c6c6

#define PD_IPT_EXT_TEL			0
#define PD_IPT_INCO_TEL			1
#define PD_IPT_CELLPHONE		2
#define PD_IPT_MAX				3

#define MAX_PARTY_NUM			2

class CProfileDlgController;

class CProfileDlg : public CBaseDlgStyleOne, 
    private IGTWASActorEvent,
    private IGTMessengerActorEvent
{
public:
	CProfileDlg(CWnd* pParent = NULL);   // ǥ Դϴ.
	virtual ~CProfileDlg();

	BOOL Create(LPCTSTR pszID, int nDlgID, CWnd* pParentWnd = NULL, CProfileDlgController* pProfileDlgController = NULL);

	DECLARE_DYNAMIC(CProfileDlg)

	void __ResourceLoad(BOOL bInit = FALSE);
	void SetReadOnly(BOOL bReadOnly);
	CString GetID()	{return m_strID;}

	enum { IDD = IDD_PROFILE_DIALOG };

protected:
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedParty1Chat();
	afx_msg void OnBnClickedParty2Chat();
	afx_msg void OnBnClickedParty1Note();
	afx_msg void OnBnClickedParty2Note();
	afx_msg void OnBnClickedOk();
	afx_msg LRESULT OnThreadFinished(WPARAM wParam, LPARAM lParam);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnStnClickedParty1Static();
	afx_msg void OnStnClickedParty2Static();

	DECLARE_MESSAGE_MAP()

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual void PostNcDestroy();

private:
	static UINT _DownloadThread(LPVOID pParam);
	static void CALLBACK _OnStatusCallBack(HINTERNET hInternet, DWORD_PTR dwContext, DWORD dwInternetStatus, LPVOID lpvStatusInformation, DWORD dwStatusInformationLength);

	virtual bool OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID);

	void DownloadThread();
	void InitControls();
	void DownloadPicture(CString strURL);
	void RequestInfo(void);
	void DrawProfileImage(CString &strImageFilePath);
	RectF GetFitSizeInRect(const SizeF &sizeMax, const SizeF &sizeOrg);
	void CloseAllInternetHandle();
	bool IsCloseMsg( MSG* pMsg );
	void CallToIPT(CString strTel);
	void SentNote(CString strReceiverID, CString strReceiverName);

	CProfileDlgController* m_pProfileDlgController;
	int m_nDlgID;

	CStatic m_stPicture;		// 
	HBITMAP m_hBitmapNoImage;

	CEdit m_editName;			// ̸
	CEdit m_editPart;			// Ҽ
	CEdit m_editPosition;		// /å
	CEdit m_editWorkstatus;		// 
	CEdit m_editExttel;			// ȣ
	CEdit m_editTel;			// ȸȣ
	CEdit m_editMobile;			// ޴
	CEdit m_editFax;			// ѽ
	CEdit m_editEmail;			// ̸
	CEdit m_editRomingtel;		// ι
	CEdit m_editCity;			// 
	CEdit m_editKeyword;		// Ű

	CToolTipCtrl	m_tooltipEmail;		// ̸ 
	CToolTipCtrl	m_tooltipKeyword;	// Ű 

	CXTPHyperLink	m_staticParty[MAX_PARTY_NUM];	// 
	CNMImgButton	m_btnPartyChat[MAX_PARTY_NUM];	// ä
	CNMImgButton	m_btnPartyNote[MAX_PARTY_NUM];	// 
	CString			m_strPartyID[MAX_PARTY_NUM];	//ID

	CString       m_sServer; 
	CString       m_sObject; 
	CString       m_sFilename;
	INTERNET_PORT m_nPort;
	DWORD         m_dwServiceType;
	HINTERNET     m_hInternetSession;
	HINTERNET     m_hHttpConnection;
	HINTERNET     m_hHttpFile;
	BOOL          m_bAbort;
	BOOL          m_bSafeToClose;
	CFile         m_FileToWrite;
	CPen		  m_penBorder;
	CPen		  m_penImageBorder;

	CString m_strID;	//    ϴ ID
	CString m_strMyID;	//  ID (m_strID   , ٸ  )

	CButton		  m_btnOK;
	CWinThread*   m_pImageDownloadThread;
	IGTWASActor  *m_pWASActor;	  
	trid_t		  m_trid;

	CImageList	m_ilIPTStatus;
	CRect		m_rtIPT[PD_IPT_MAX];		// ȣ, ȸȭ, ޴ IPT  
	int			m_nCursor;
	HCURSOR		m_hLinkCursor;		// Cursor for hyperlink
	NTIPTStatusType m_eIPTStatus;
	NE_MEMBER_DATA m_userData;
	HBRUSH		m_hBrushStatic;
	
};
